import create from '../../_styles/utils/create-component-base'
import commonVariables from './_common'

export default create({
  theme: 'light',
  name: 'Button',
  getDerivedVariables ({ base, derived }) {
    return {
      ...commonVariables(base, derived),
      opacityDisabled: derived.opacityDisabled,
      // default type
      color: 'transparent',
      colorHover: 'transparent',
      colorPressed: 'transparent',
      colorFocus: 'transparent',
      colorDisabled: 'transparent',
      textColor: derived.textColor2,
      textColorHover: derived.primaryColorHover,
      textColorPressed: derived.primaryColorPressed,
      textColorFocus: derived.primaryColorHover,
      textColorDisabled: derived.textColor2,
      textColorText: derived.textColor2,
      textColorTextHover: derived.primaryColorHover,
      textColorTextPressed: derived.primaryColorPressed,
      textColorTextFocus: derived.primaryColorHover,
      textColorTextDisabled: derived.textColor2,
      textColorGhost: derived.textColor2,
      textColorGhostHover: derived.primaryColorHover,
      textColorGhostPressed: derived.primaryColorPressed,
      textColorGhostFocus: derived.primaryColorHover,
      textColorGhostDisabled: derived.textColor2,
      borderColor: derived.borderColorOverlay,
      borderColorHover: derived.primaryColorHover,
      borderColorPressed: derived.primaryColorPressed,
      borderColorFocus: derived.primaryColorHover,
      borderColorDisabled: derived.borderColorOverlay,
      rippleColor: derived.primaryColor,
      iconColor: derived.textColor2,
      // primary
      colorPrimary: derived.primaryColor,
      colorHoverPrimary: derived.primaryColorHover,
      colorPressedPrimary: derived.primaryColorPressed,
      colorFocusPrimary: derived.primaryColorHover,
      colorDisabledPrimary: derived.primaryColor,
      textColorPrimary: derived.baseColor,
      textColorHoverPrimary: derived.baseColor,
      textColorPressedPrimary: derived.baseColor,
      textColorFocusPrimary: derived.baseColor,
      textColorDisabledPrimary: derived.baseColor,
      textColorTextPrimary: derived.textColor2,
      textColorTextHoverPrimary: derived.primaryColorHover,
      textColorTextPressedPrimary: derived.primaryColorPressed,
      textColorTextFocusPrimary: derived.primaryColorHover,
      textColorTextDisabledPrimary: derived.textColor2,
      textColorGhostPrimary: derived.primaryColor,
      textColorGhostHoverPrimary: derived.primaryColorHover,
      textColorGhostPressedPrimary: derived.primaryColorPressed,
      textColorGhostFocusPrimary: derived.primaryColorHover,
      textColorGhostDisabledPrimary: derived.primaryColor,
      borderColorPrimary: derived.primaryColor,
      borderColorHoverPrimary: derived.primaryColorHover,
      borderColorPressedPrimary: derived.primaryColorPressed,
      borderColorFocusPrimary: derived.primaryColorHover,
      borderColorDisabledPrimary: derived.primaryColor,
      rippleColorPrimary: derived.primaryColor,
      iconColorPrimary: derived.primaryColor,
      // info
      colorInfo: derived.infoColor,
      colorHoverInfo: derived.infoColorHover,
      colorPressedInfo: derived.infoColorPressed,
      colorFocusInfo: derived.infoColorHover,
      colorDisabledInfo: derived.infoColor,
      textColorInfo: derived.baseColor,
      textColorHoverInfo: derived.baseColor,
      textColorPressedInfo: derived.baseColor,
      textColorFocusInfo: derived.baseColor,
      textColorDisabledInfo: derived.baseColor,
      textColorTextInfo: derived.textColor2,
      textColorTextHoverInfo: derived.infoColorHover,
      textColorTextPressedInfo: derived.infoColorPressed,
      textColorTextFocusInfo: derived.infoColorHover,
      textColorTextDisabledInfo: derived.textColor2,
      textColorGhostInfo: derived.infoColor,
      textColorGhostHoverInfo: derived.infoColorHover,
      textColorGhostPressedInfo: derived.infoColorPressed,
      textColorGhostFocusInfo: derived.infoColorHover,
      textColorGhostDisabledInfo: derived.infoColor,
      borderColorInfo: derived.infoColor,
      borderColorHoverInfo: derived.infoColorHover,
      borderColorPressedInfo: derived.infoColorPressed,
      borderColorFocusInfo: derived.infoColorHover,
      borderColorDisabledInfo: derived.infoColor,
      rippleColorInfo: derived.infoColor,
      iconColorInfo: derived.infoColor,
      // success
      colorSuccess: derived.successColor,
      colorHoverSuccess: derived.successColorHover,
      colorPressedSuccess: derived.successColorPressed,
      colorFocusSuccess: derived.successColorHover,
      colorDisabledSuccess: derived.successColor,
      textColorSuccess: derived.baseColor,
      textColorHoverSuccess: derived.baseColor,
      textColorPressedSuccess: derived.baseColor,
      textColorFocusSuccess: derived.baseColor,
      textColorDisabledSuccess: derived.baseColor,
      textColorTextSuccess: derived.textColor2,
      textColorTextHoverSuccess: derived.successColorHover,
      textColorTextPressedSuccess: derived.successColorPressed,
      textColorTextFocusSuccess: derived.successColorHover,
      textColorTextDisabledSuccess: derived.textColor2,
      textColorGhostSuccess: derived.successColor,
      textColorGhostHoverSuccess: derived.successColorHover,
      textColorGhostPressedSuccess: derived.successColorPressed,
      textColorGhostFocusSuccess: derived.successColorHover,
      textColorGhostDisabledSuccess: derived.successColor,
      borderColorSuccess: derived.successColor,
      borderColorHoverSuccess: derived.successColorHover,
      borderColorPressedSuccess: derived.successColorPressed,
      borderColorFocusSuccess: derived.successColorHover,
      borderColorDisabledSuccess: derived.successColor,
      rippleColorSuccess: derived.successColor,
      iconColorSuccess: derived.successColor,
      // warning
      colorWarning: derived.warningColor,
      colorHoverWarning: derived.warningColorHover,
      colorPressedWarning: derived.warningColorPressed,
      colorFocusWarning: derived.warningColorHover,
      colorDisabledWarning: derived.warningColor,
      textColorWarning: derived.baseColor,
      textColorHoverWarning: derived.baseColor,
      textColorPressedWarning: derived.baseColor,
      textColorFocusWarning: derived.baseColor,
      textColorDisabledWarning: derived.baseColor,
      textColorTextWarning: derived.textColor2,
      textColorTextHoverWarning: derived.warningColorHover,
      textColorTextPressedWarning: derived.warningColorPressed,
      textColorTextFocusWarning: derived.warningColorHover,
      textColorTextDisabledWarning: derived.textColor2,
      textColorGhostWarning: derived.warningColor,
      textColorGhostHoverWarning: derived.warningColorHover,
      textColorGhostPressedWarning: derived.warningColorPressed,
      textColorGhostFocusWarning: derived.warningColorHover,
      textColorGhostDisabledWarning: derived.warningColor,
      borderColorWarning: derived.warningColor,
      borderColorHoverWarning: derived.warningColorHover,
      borderColorPressedWarning: derived.warningColorPressed,
      borderColorFocusWarning: derived.warningColorHover,
      borderColorDisabledWarning: derived.warningColor,
      rippleColorWarning: derived.warningColor,
      iconColorWarning: derived.warningColor,
      // error
      colorError: derived.errorColor,
      colorHoverError: derived.errorColorHover,
      colorPressedError: derived.errorColorPressed,
      colorFocusError: derived.errorColorHover,
      colorDisabledError: derived.errorColor,
      textColorError: derived.baseColor,
      textColorHoverError: derived.baseColor,
      textColorPressedError: derived.baseColor,
      textColorFocusError: derived.baseColor,
      textColorDisabledError: derived.baseColor,
      textColorTextError: derived.textColor2,
      textColorTextHoverError: derived.errorColorHover,
      textColorTextPressedError: derived.errorColorPressed,
      textColorTextFocusError: derived.errorColorHover,
      textColorTextDisabledError: derived.textColor2,
      textColorGhostError: derived.errorColor,
      textColorGhostHoverError: derived.errorColorHover,
      textColorGhostPressedError: derived.errorColorPressed,
      textColorGhostFocusError: derived.errorColorHover,
      textColorGhostDisabledError: derived.errorColor,
      borderColorError: derived.errorColor,
      borderColorHoverError: derived.errorColorHover,
      borderColorPressedError: derived.errorColorPressed,
      borderColorFocusError: derived.errorColorHover,
      borderColorDisabledError: derived.errorColor,
      rippleColorError: derived.errorColor,
      iconColorError: derived.errorColor
    }
  }
})
